for i = 1, 7
freeslot("S_MAGICSPARK"..i, "SPR_MSPK", "SPR_MMTM", "S_MAGICPANEL"..i, "MT_ICEPLATFORMMAGIC", "S_ICEPLATFORMMAGIC")
end

for i = 1, 7
freeslot("S_MAGICPENTOGRAM1", "S_MAGICPENTOGRAM2", "SPR_PENT", "S_INSTASHIELD"..i, "SPR_INST", "SPR_ICEP", "MT_TORNADO", "S_TORNADO")
end

freeslot("SPR_BCIR", "S_BOOSTCIRCLE")

states[S_BOOSTCIRCLE] = {SPR_BCIR, A|FF_FULLBRIGHT, 8, nil, 0, 0, S_NULL}

states[S_INSTASHIELD1] = {SPR_INST, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD2}
states[S_INSTASHIELD2] = {SPR_INST, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD3}
states[S_INSTASHIELD3] = {SPR_INST, C|FF_FULLBRIGHT, 4, nil, 0, 0, S_INSTASHIELD4}
states[S_INSTASHIELD4] = {SPR_INST, D|FF_FULLBRIGHT, 3, nil, 0, 0, S_INSTASHIELD5}
states[S_INSTASHIELD5] = {SPR_INST, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD6}
states[S_INSTASHIELD6] = {SPR_INST, F|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD7}
states[S_INSTASHIELD7] = {SPR_INST, G|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD1}

states[S_MAGICSPARK1] = {SPR_MSPK, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_MAGICSPARK2}
states[S_MAGICSPARK2] = {SPR_MSPK, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_MAGICSPARK3}
states[S_MAGICSPARK3] = {SPR_MSPK, C|FF_FULLBRIGHT, 4, nil, 0, 0, S_MAGICSPARK4}
states[S_MAGICSPARK4] = {SPR_MSPK, D|FF_FULLBRIGHT, 3, nil, 0, 0, S_MAGICSPARK5}
states[S_MAGICSPARK5] = {SPR_MSPK, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_MAGICSPARK6}
states[S_MAGICSPARK6] = {SPR_MSPK, F|FF_FULLBRIGHT, 2, nil, 0, 0, S_MAGICSPARK7}
states[S_MAGICSPARK7] = {SPR_MSPK, G|FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}

states[S_MAGICPANEL1] = {SPR_MMTM, A|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL2] = {SPR_MMTM, B|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL3] = {SPR_MMTM, C|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL4] = {SPR_MMTM, D|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL5] = {SPR_MMTM, E|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL6] = {SPR_MMTM, F|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL7] = {SPR_MMTM, G|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}

states[S_MAGICPENTOGRAM1] = {SPR_PENT, A|FF_FULLBRIGHT|FF_PAPERSPRITE|FF_TRANS20, 50, nil, 1, 0, S_NULL}
states[S_MAGICPENTOGRAM2] = {SPR_PENT, B|FF_FULLBRIGHT|FF_PAPERSPRITE|FF_TRANS20, 50, nil, 0, 0, S_NULL}

mobjinfo[MT_ICEPLATFORMMAGIC] = {
	doomednum = -1,
	spawnstate = S_ICEPLATFORMMAGIC,
	spawnhealth = 1,
	speed = FRACUNIT*60,
	radius = 50*FRACUNIT,
	height = 10*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY|MF_SOLID|MF_NOGRAVITY
}

states[S_ICEPLATFORMMAGIC] = {SPR_ICEP, A|FF_FULLBRIGHT|FF_FLOORSPRITE|FF_ADD, TICRATE*10, nil, 1, 0, S_NULL}


freeslot("SKINCOLOR_MAGICALMETAL")

skincolors[SKINCOLOR_MAGICALMETAL] = {
	name = "Magical_Metal",
	ramp = {160,161,162,163,133,134,135,136,137,153,154,155,156,157,158,159},
    invcolor = SKINCOLOR_COBALT,
    invshade = 0,
    chatcolor = V_BLUEMAP,
    accessible = true
}	

freeslot("MT_MAGICAURA", "S_MAGICAURA")

local byebye = {
	[0] = FF_FULLBRIGHT,
	[1] = FF_TRANS90,
	[2] = FF_TRANS80,
	[3] = FF_TRANS70,
	[4] = FF_TRANS60,
	[5] = FF_TRANS50,
	[6] = FF_TRANS40,
	[7] = FF_TRANS30,
	[8] = FF_TRANS20,
	[9] = FF_TRANS10
}

mobjinfo[MT_MAGICAURA] = {
	doomednum = -1,
	spawnstate = S_NULL,
	spawnhealth = 1,
	speed = FRACUNIT*60,
	radius = 10*FRACUNIT,
	height = 10*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

states[S_MAGICAURA] = {SPR_NULL, A|FF_FULLBRIGHT, 2, nil, 1, 0, S_NULL}

mobjinfo[MT_TORNADO] = {
	doomednum = -1,
	spawnstate = S_TORNADO,
	spawnhealth = 1,
	speed = FRACUNIT*5,
	radius = 10*FRACUNIT,
	height = 10*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_MISSILE|MF_NOGRAVITY
}

states[S_TORNADO] = {SPR_THOK, A|FF_FULLBRIGHT, TICRATE*5, nil, 0, 0, S_NULL}

rawset(_G, "F_SearchForPlayers", function(p)
	local lastmo
	local dist
	local lastdist = 0

	for mo in mobjs.iterate()
		dist = P_AproxDistance(P_AproxDistance(p.mo.x - mo.x, p.mo.y - mo.y), p.mo.z - mo.z)
		
		local exist = 1
		if lastmo and lastdist
			exist = dist < lastdist
		else
			exist = 1
		end
		
		local fren = 1
		if gametyperules & GTR_TEAMS
			fren = mo.player.ctfteam == p.ctfteam
		else
			fren = 1
		end

		if mo != p.mo
			if P_CheckSight(p.mo, mo)
				if mo.type == MT_PLAYER
				and mo.player
				and dist <= 500*FRACUNIT
					if exist
					and fren
						lastmo = mo
						lastdist = dist
					end	
				end
			end	
		end
	end
	return lastmo
end)

rawset(_G, "P_SpawnAura", function(player, colorr, scaleadd, nope)
	local addscale1 = FRACUNIT/15
	local addscale2 = FRACUNIT/13
	if nope
		addscale1 = 1
		addscale2 = 1
	else
		addscale1 = FRACUNIT/15
		addscale2 = FRACUNIT/13
	end
	local aura = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
	aura.target = player.mo
	aura.tracer = player.mo
	aura.state = S_MAGICAURA
	aura.skin = player.mo.skin
	aura.color = colorr
	aura.sprite = player.mo.sprite
	aura.sprite2 = player.mo.sprite2
	aura.spriteyscale = (FRACUNIT + scaleadd) + addscale2 + FixedMul(cos((leveltime%360)*ANG1*5), addscale1)
	aura.spritexscale = (FRACUNIT + scaleadd) + addscale2 + FixedMul(cos((leveltime%360)*ANG1*5), addscale1)
	aura.fuse = 2
	aura.colorized = true
	aura.aura = true
	if player.followmobj
	and player.followmobj.type != MT_METALJETFUME
		local aura2 = P_SpawnMobjFromMobj(player.followmobj, 0, 0, 0, MT_OVERLAY)
		aura2.target = player.followmobj
		aura2.tracer = player.followmobj
		aura2.state = S_MAGICAURA
		aura2.skin = player.mo.skin
		aura2.color = colorr
		aura2.sprite = player.followmobj.sprite
		aura2.sprite2 = player.followmobj.sprite2
		aura2.spriteyscale = (FRACUNIT + scaleadd) + addscale2 + FixedMul(cos((leveltime%360)*ANG1*5), addscale1)
		aura2.spritexscale = (FRACUNIT + scaleadd) + addscale2 + FixedMul(cos((leveltime%360)*ANG1*5), addscale1)
		aura2.fuse = 2
		aura2.colorized = true
		aura2.aura = true
		aura2.followmobjaura = true
		aura2.targetskin = player.mo.skin
	end
	return aura
end)

rawset(_G, "P_ParabolicMove", function(mo, px, py, pz, speed) //Arrow movement func
	local dx = px - mo.x
	local dy = py - mo.y
	local dz = pz - mo.z
	local dh = P_AproxDistance(dx, dy)
	local c = FixedDiv(dx, dh)
	local s = FixedDiv(dy, dh)
	local fixConst = FixedDiv(speed, gravity)
	mo.momx = FixedMul(c, speed)
	mo.momy = FixedMul(s, speed)
	mo.momz = (FixedDiv(dh, 2*fixConst) + FixedDiv(dz, FixedDiv(dh, fixConst/2)))
end)

rawset(_G, "P_FlyTo", function(mo, fx, fy, fz, sped) //Can combo with AproxDist to make it move smoother(when near the coordinates moves slower)
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
			
		mo.momx = FixedMul(FixedDiv(fx - mo.x, flyto), sped)
		mo.momy = FixedMul(FixedDiv(fy - mo.y, flyto), sped)
		mo.momz = FixedMul(FixedDiv(fz - mo.z, flyto), sped)
	end	
end) 

local function SpawnTornado(mo)
	for i = 1, 3
		local ns = (ANG1*120)*i + ((leveltime%360)*ANG15)
		local windx = FixedMul(100*FRACUNIT, cos(ns))
		local windy = FixedMul(100*FRACUNIT, sin(ns))
		local wind = P_SpawnMobjFromMobj(mo, windx, windy, 5*FRACUNIT, MT_DUSTLAYER)
		wind.frame = $|FF_PAPERSPRITE
		wind.fuse = 5
		wind.scale = FRACUNIT
		wind.angle = R_PointToAngle2(wind.x, wind.y, mo.x, mo.y) + ANGLE_90
	end
	for i = 1, 6
		local ns = ANG60*i + ((leveltime%360)*ANG10)
		local windx = FixedMul(150*FRACUNIT, cos(ns))
		local windy = FixedMul(150*FRACUNIT, sin(ns))
		local wind = P_SpawnMobjFromMobj(mo, windx, windy, 100*FRACUNIT, MT_DUSTLAYER)
		wind.frame = $|FF_PAPERSPRITE
		wind.fuse = 5
		wind.scale = FRACUNIT
		wind.angle = R_PointToAngle2(wind.x, wind.y, mo.x, mo.y) + ANGLE_90
	end
	for i = 1, 12
		local ns = ANG30*i + ((leveltime%360)*(ANG1*5))
		local windx = FixedMul(200*FRACUNIT, cos(ns))
		local windy = FixedMul(200*FRACUNIT, sin(ns))
		local wind = P_SpawnMobjFromMobj(mo, windx, windy, 225*FRACUNIT, MT_DUSTLAYER)
		wind.frame = $|FF_PAPERSPRITE
		wind.fuse = 5
		wind.scale = FRACUNIT
		wind.angle = R_PointToAngle2(wind.x, wind.y, mo.x, mo.y) + ANGLE_90
	end
	for i = 1, 6
		local ranx = FixedMul(P_RandomRange(0, 150)*FRACUNIT, cos(P_RandomRange(0, 360)*ANG1))
		local rany = FixedMul(P_RandomRange(0, 150)*FRACUNIT, sin(P_RandomRange(0, 360)*ANG1))
		local ranz = P_RandomRange(0, 150)*FRACUNIT
		local dark = P_SpawnMobjFromMobj(mo, ranx, rany, ranz, MT_THOK)
		dark.color = SKINCOLOR_SILVER
		dark.fuse = TICRATE/3
		dark.tics = TICRATE/3
		dark.scale = P_RandomRange(1, 3)*FRACUNIT
	end
end

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.aura
			if mo.fuse
				local bop = byebye[mo.fuse%9]
				mo.frame = $|bop|FF_FULLBRIGHT
			end
			if mo.target
			and mo.state == S_MAGICAURA
				if not mo.targetskin
					mo.skin = mo.target.skin
				else
					mo.skin = mo.targetskin
				end	
				mo.sprite = mo.target.sprite
				mo.sprite2 = mo.target.sprite2
				mo.frame = mo.target.frame & ~FF_TRANSMASK
				mo.blendmode = AST_ADD
			end
		end
		if mo.type == MT_ICEPLATFORMMAGIC
			local ranx = FixedMul(50*FRACUNIT, cos(P_RandomRange(0, 360)*ANG1))
			local rany = FixedMul(50*FRACUNIT, sin(P_RandomRange(0, 360)*ANG1))
			local snow = P_SpawnMobjFromMobj(mo, ranx, rany, -FRACUNIT, MT_SNOWFLAKE)
			snow.fuse = TICRATE
			if mo.tics == 1
				for i = 1, 16
					local ranx = FixedMul(50*FRACUNIT, cos(P_RandomRange(0, 360)*ANG1))
					local rany = FixedMul(50*FRACUNIT, sin(P_RandomRange(0, 360)*ANG1))
					local deb = P_SpawnMobjFromMobj(mo, ranx, rany, -FRACUNIT, MT_ROCKCRUMBLE9)
					P_SetObjectMomZ(deb, P_RandomRange(-10, 0)*FRACUNIT, true)
				end
			end
		end
		if mo.type == MT_TORNADO
			mo.flags2 = $|MF2_DONTDRAW
			SpawnTornado(mo)
			if not S_SoundPlaying(mo, sfx_s3kcel)
				S_StartSound(mo, sfx_s3kcel)
			end
			for mobj in mobjs.iterate()
				if mobj and mobj.valid
				and mobj != mo
				and R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y) <= 500*FRACUNIT
				and mobj.z <= (mo.z + 150*FRACUNIT) and (mobj.z + 50*FRACUNIT) >= mo.z
					if (mobj.flags & MF_ENEMY
					or mobj.flags & MF_BOSS
					or mobj.flags & MF_MISSILE)
					and mobj.type != MT_TORNADO
						local yis = P_SpawnMobjFromMobj(mo, 0, 0, 10*FRACUNIT, MT_DUSTLAYER)
						yis.angle = R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y) + ANGLE_90
						P_InstaThrust(yis, R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y), 30*FRACUNIT)
						yis.frame = $|FF_PAPERSPRITE
						yis.fuse = 15
						P_Thrust(mobj, R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y), 15*FRACUNIT)
						if not (mobj.flags & MF_MISSILE)
							P_SetObjectMomZ(mobj, FRACUNIT/20, true)
						end
					end
				end
				if mobj and mobj.valid
				and R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y) <= 200*FRACUNIT
				and mobj.z <= (mo.z + 150*FRACUNIT) and (mobj.z + 50*FRACUNIT) >= mo.z
				and mo.target == mobj and mobj.player
				and mo.tics <= (TICRATE*4 - 15)
					P_SetObjectMomZ(mobj, FRACUNIT/3*2, true)
					if not P_IsObjectOnGround(mobj)
						mobj.player.pflags = $|PF_JUMPED
						mobj.player.pflags = $ & ~PF_THOKKED
					end	
				end
			end
		end
		if mo.platformball
			local ice = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			ice.state = mo.state
			ice.scale = FRACUNIT/3
			ice.destscale = -1
			ice.scalespeed = FRACUNIT/20
			ice.fuse = 15
			ice.colorized = true
			ice.color = SKINCOLOR_ICY
			if mo.returnto
				mo.returnto = $ - 1
			end
			if mo.wherx and mo.whery and mo.wherz
				local aprx = P_AproxDistance(P_AproxDistance(mo.wherx - mo.x, mo.whery - mo.y), mo.wherz - mo.z)
				if aprx <= 150*FRACUNIT
				or not (mo.returnto)
					P_FlyTo(mo, mo.wherx, mo.whery, mo.wherz, 20*FRACUNIT)
				end
				if aprx <= 50*FRACUNIT
					local plat = P_SpawnMobjFromMobj(mo, mo.wherx-mo.x, mo.whery-mo.y, mo.wherz-mo.z, MT_ICEPLATFORMMAGIC)
					plat.scale = FRACUNIT
					S_StartSound(plat, sfx_shattr)
					P_KillMobj(mo)
				end
			end
		end
	end
end)